/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * main.cc
 * Copyright (C) eoin mcmahon 2010 <eoinmcmahon0@AT@gmail.com>
 * 
 * main.cc is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * main.cc is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


#include <config.h>
#include <libglademm.h>
#include <gtkmm.h>
#include <iostream>
#include <typeinfo>
#include <glibmm.h>
#include <gconf/gconf-client.h>
#include <glibmm/object.h>
#include <glibmm/error.h>
#include <gconfmm.h>


class Data;
class DerivedWindow;
class MModel;
class ModelRow;
class vbManage;
class ViewRow;
class View;
class ViewTitle;
   

#include "data.hpp"
#include "model-row.hpp"
#include "view-row.hpp"
#include "connection.hpp"
#include "m-model.hpp"
#include "view.hpp"
#include "derived-window.hpp"
#include "vb-manage.hpp"



#ifdef ENABLE_NLS
#  include <libintl.h>
#endif


/* For testing purposes use the local (not installed) glade file */
/*
#ifdef FOR_INSTALLATION
#define GLADE_FILE PACKAGE_DATA_DIR"/vbmanage-/glade/vbmanage-.glade" 
#else
#define GLADE_FILE "vbmanage-.glade"
#endif */ /* FOR_INSTALLATION */ 

Glib::RefPtr<Gnome::Conf::Client> gconfclient;
Glib::RefPtr<Gdk::Screen> gscreen;
Glib::ustring fontname;
Glib::ustring bg_window;
Glib::ustring bg_title;
Glib::ustring bg_row_odd;
Glib::ustring bg_row_even;
const Glib::ustring opening("<span font_desc=\"");
const Glib::ustring middle("\" >");
const Glib::ustring closing("</span>");
const int hpadding(10);
bool autorun;
bool show_error_messages;

int
main (int argc, char *argv[])
{
	Gnome::Conf::init();
	gconfclient = Gnome::Conf::Client::get_default_client();
	gconfclient->add_dir("/apps/vbmanage", Gnome::Conf::CLIENT_PRELOAD_RECURSIVE);
	
	if(!Glib::thread_supported()) Glib::thread_init();

	
	//~ std::vector<Glib::ustring> filelist;
	//~ filelist = Gtk::RC::get_default_files();
	//~ std::vector<Glib::ustring>::iterator flIt;
	//~ for (flIt = filelist.begin() ; flIt != filelist.end() ; flIt++)
	//~ {
		//~ std::cout << *flIt << endl;
	//~ }
	 Gtk::Main kit(argc, argv);
	
	
	
	int x,y, width, height;
	/*std::string mcline;
	ifstream vbmanage_conf ("vbManage.conf", ios::in);
		if (vbmanage_conf.is_open())
		{
			
				getline(vbmanage_conf, mcline);
				size_t comma;
				comma = mcline.find(',');
				size_t semicolon = mcline.find(";");
				size_t colon = mcline.find(":");
				x = atoi(mcline.substr(0, comma ).c_str());
				y = atoi(mcline.substr(comma+1, semicolon-comma -1).c_str());
				width = atoi(mcline.substr(semicolon+1, colon-semicolon-1).c_str());
				height = atoi(mcline.substr(colon+1).c_str());
//				cout << x << "," << y << ";" << width << ":" << height <<endl<<endl;
				
			
			vbmanage_conf.close();
		}
		else
		{
			cout << "Could not open config file" << endl;
			x = 0;
			y = 0;
			width = 600;
			height = 400;
		}*/
	
	//Gtk::Allocation a(x,y,width,height);
	//vbManage vbmanage(a);
	::gscreen = Gdk::Screen::get_default();
	vbManage vbmanage;
	
	//cout<< "Screen width = " << ::gscreen->get_width() << " Height = " << 
	//	::gscreen->get_height() << endl;
	
//	std::cout << "Invoking vbManage" << std::endl;
	Gtk::Main::run(*vbmanage.pWindow);
	return 0;
}
