/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * trunk
 * Copyright (C) Eoin McMahon 2010 <eoinmcmahon0@AT@gmail.com>
 * 
 * trunk is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * trunk is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef _DERIVED_WINDOW_HPP_
#define _DERIVED_WINDOW_HPP_

#include <glib.h>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <list>
#include <fstream>
#include <time.h>
#include <gtkmm.h>
#include <libglademm/xml.h>
#include <typeinfo>
#include <gconfmm.h>

extern Glib::RefPtr<Gnome::Conf::Client> gconfclient;

class DerivedWindow: public Gtk::Window 
{
public:
		//typedef GtkWindow BaseObjectType;
		DerivedWindow(BaseObjectType* cobject, const Glib::RefPtr<Gnome::Glade::Xml>& refGlade) ;
	virtual ~DerivedWindow() {};
protected:

	virtual bool on_delete_event(GdkEventAny * event);
		virtual void on_hide();
private:

};

#endif // _DERIVED_WINDOW_HPP_
